
from LeibCongruence import reduceMatrix
from LeibClasses import *

from org.uacalc.alg import BasicAlgebra
from org.uacalc.alg import FreeAlgebra


class Logic:
	#class of a logic given by an algebra and a subset (filter) over it
	
	#observe that while the original algebra can be changed 
	#modifying the object of the initialization, internally a 
	#copy of the reduced algebra is generated and it will be 
	#the one over which the calculus will be done. treat with care 
	#and do not expect weird results
	
    def __init__(self, name, Algebra, filter):
        self.name = name
        self.algebra = Algebra
        if [x for x in filter if x not in Algebra.universe()] != []:
            raise ValueError("filter must be a subset of the universe.")
        self.filter = filter
        [self.ralgebra, self.rfilter] = reduceMatrix(Algebra, filter)
        self.protoalgebraic = -1
        self.equivalential = -1
        self.truthEquational = -1
        self.free2 = 0
        self.free1 = 0
       

    def getAlgebra(self):
    	return self.ralgebra
    
    def getOriginalAlgebra(self):
    	return self.algebra    	
    
    def getUniverse(self):
    	return self.ralgebra.universe()
    
    def getOriginalUniverse(self):
    	return self.algebra.universe()
    	
    def elementIndex(self, e):
    	return self.ralgebra.elementIndex(e)
    	
    def getFilter(self):
    	return self.rfilter
    def getOriginalFilter(self):
    	return self.filter
    	
    def getFree2(self):
    	if self.free2 == 0:
    		self.free2 = FreeAlgebra("falgebra2", self.ralgebra, 2, True)
    	return self.free2

    def getFree1(self):
    	if self.free1 == 0:
    		self.free1 = FreeAlgebra("falgebra2", self.ralgebra, 1, True)
    	return self.free1
    
    def isProtoalgebraic(self):
    	if self.protoalgebraic == -1:
    		[self.protoalgebraic, self.protoDelta] = protoalgebraic(self)
    	if self.protoalgebraic == False:
    		print "The logic ", self.name, " IS NOT protoalgebraic."
    		return
    	if self.protoalgebraic == True:
    		print "The logic ", self.name, " IS protoalgebraic."
    		print "A possible Delta set is:"
    		for term in self.protoDelta:
				print(term.toString())
    		return
    		
    def isEquivalential(self):
    	if self.equivalential == -1:
    		[self.equivalential, self.equivDelta] = equivalential(self)
    	if self.equivalential == False:
    		print "The logic ", self.name, " IS NOT equivalential."
    		return
    	if self.equivalential == True:
    		print "The logic ", self.name, " IS equivalential."
    		print "A possible Delta set is:"
    		for term in self.equivDelta:
				print(term.toString())
    		return
    	
    def isTruthEquational(self):
    	if self.truthEquational == -1:
    		[self.truthEquational, self.tau] = truthEquational(self)
    	if self.truthEquational == False:
    		print "The logic ", self.name, " IS NOT truth equational."
    		return
    	if self.truthEquational == True:
    		print "The logic ", self.name, " IS truth equational."
    		print "A possible Tau set is:"
    		for term in self.tau:
				print term[0].toString(), "=", term[1].toString()
    		return
    	
    	