import sys
from Operations import Operation
from org.uacalc.alg import BasicAlgebra
from org.uacalc.io import AlgebraIO

def product(*args, **kwds):
    # product('ABCD', 'xy') --> Ax Ay Bx By Cx Cy Dx Dy
    # product(range(2), repeat=3) --> 000 001 010 011 100 101 110 111
    pools = map(tuple, args) * kwds.get('repeat', 1)
    result = [[]]
    for pool in pools:
        result = [x+[y] for x in result for y in pool]
    for prod in result:
        yield tuple(prod)


def readManualAlgebra():
	print "Reading a new Algebra..."
	size = int(raw_input("Enter the cardinality of the algebra: "))
	operations  = []
	np = raw_input("Do you want to add an operation? (y/n): ")
	while np == "y":
		name = raw_input("Enter the name: ")
		arity = int(raw_input("Enter the arity: "))
		if arity > 1:
			print("--introduce the values--")
			fun = []
			arguments = list(product(range(0, size), repeat=arity))
			for ar in arguments:
				v = int(raw_input(name+str(ar) + "= "))
				fun.append([ar, v])
			op = Operation(fun, name, arity, size)
		if arity == 1:
			print("--introduce the values--")
			fun = []
			arguments = range(0, size)
			for ar in arguments:
				v = int(raw_input(name+"("+str(ar) + ")= "))
				fun.append([ar, v])
			op = Operation(fun, name, arity, size)
		if arity == 0:
			v = int(raw_input("Enter the constant value: "))
			op = Operation(v, name, 0, size)
		operations.append(op)
		np = raw_input("Do you want to add an operation? (y/n): ")
	
	algebra = BasicAlgebra("Alg", size, operations)
	#print("check:")
	#print "   alg.getName() = ", algebra.getName()        
	#print "   alg.universe() = ", algebra.universe()
	
	
	save = raw_input("Do you want to save the algebra to a file in folder ALGEBRAS? (y/n): ")
	if save == "y":
		path = raw_input("Write the name of the file: ")
		AlgebraIO.writeAlgebraFile(algebra, "ALGEBRAS/"+path)
	return algebra